package com.franckbarbier.Universite;

class Personne {
    /* ... */
}

public class Etudiant extends Personne {

    private final String _n_etudiant;
    private final String _n_INSEE;

    Etudiant(String n_etudiant, String n_INSEE) {
        this._n_etudiant = n_etudiant;
        this._n_INSEE = n_INSEE;
    }

    @Override
    public boolean equals(Object etudiant) {
        if (etudiant == null || this.getClass() != etudiant.getClass()) {
            return false;
        }
        if (this == etudiant) {
            return true;
        }
        final Etudiant e = (Etudiant) etudiant;
        if (this._n_INSEE.equals(e._n_INSEE)) {
            return true;
        }
        return false;
    }

    @Override
    public int hashCode() {
        return this._n_INSEE.hashCode();
    }

    public static void main(String parametres[]) {
        Etudiant XX = new Etudiant("1", "2000164444555");
        Etudiant XY = new Etudiant("2", "1010264222333");
        Etudiant XZ = new Etudiant_etranger("3", "", "CODE PAYS ORIGINE");
        Etudiant_etranger XW = new Etudiant_etranger("4", "", "AUTRE CODE PAYS ORIGINE");
        Universite<Etudiant> mon_universite = new Universite<>(XX, XY, XZ, XW);
        System.out.println(mon_universite.size());
    }
}
